using System;
using System.Collections.Generic;
//using System.Text;
using javax.crypto;
using java.security;
using Org.BouncyCastle.Crypto;

namespace Proyecto
{
    /*
     * Clase Datos: almacena los datos del usuario que ha iniciado la aplicacin, el
     * algoritmo del sistema y la lista de usuarios
     * Autor: Juan lvaro Muoz Naranjo
     * Fecha: Junio de 2007
     */
    static class Datos
    {
        private static string algoritmoSistema = null; //algoritmo con que se cifra el archivo de usuarios. claveSistema es una clave para este algoritmo
        private static SecretKey claveSistema = null; //clave del sistema con la que se cifra el archivo de usuarios
        private static Usuarios usuarios = null; //lista de usuarios del sistema, obtenida del archivo usuarios.usr

        private static string nombreUsuario = null; //nombre del usuario que inici la aplicacin
        private static PrivateKey clavePrivadaRSAUsuario = null; //clave privada del usuario que inici la aplicacin
        private static AsymmetricKeyParameter clavePrivadaElGamalUsuario = null; //clave privada del usuario que inici la aplicacin

        internal static string AlgoritmoSistema
        {
            set
            {
                algoritmoSistema = value;
            }
            get
            {
                return algoritmoSistema;
            }
        }

        internal static SecretKey ClaveSistema
        {
            set
            {
                claveSistema = value;
            }
            get
            {
                return claveSistema;
            }
        }

        internal static Usuarios Usuarios
        {
            set
            {
                usuarios = value;
            }
            get
            {
                return usuarios;
            }
        }

        internal static string NombreUsuario
        {
            set
            {
                nombreUsuario = value;
            }
            get
            {
                return nombreUsuario;
            }
        }

        internal static PrivateKey ClavePrivadaRSAUsuario
        {
            set
            {
                clavePrivadaRSAUsuario = value;
            }
            get
            {
                return clavePrivadaRSAUsuario;
            }
        }

        internal static AsymmetricKeyParameter ClavePrivadaElGamalUsuario
        {
            set
            {
                clavePrivadaElGamalUsuario = value;
            }
            get
            {
                return clavePrivadaElGamalUsuario;
            }
        }

        internal static void limpiar()
        {
            claveSistema = null;
            usuarios = null;
            clavePrivadaRSAUsuario = null;
            clavePrivadaElGamalUsuario = null;
            //no limpiamos algoritmoSistema ni nombreUsuario porque al ser string son inmutables
        }
    }
}
