using System;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;

namespace Proyecto
{
    /*
     * Clase InfoCabecera: informacin almacenada en una cabecera de un archivo cifrado
     * Autor: Juan lvaro Muoz Naranjo
     * Fecha: Junio de 2007
     */
    [Serializable]
    class InfoCabecera
    {
        private string nombre;
        private string algoritmo;
        private string paramsAlgoritmo; //actualmente no se usa
        private byte[] claveSimetrica;

        public InfoCabecera(string nombre, string algoritmo, string paramsAlgoritmo, byte[] claveSimetrica)
        {
            this.nombre = nombre;
            this.algoritmo = algoritmo;
            this.paramsAlgoritmo = paramsAlgoritmo;
            this.claveSimetrica = claveSimetrica;
        }

        public string Nombre
        {
            get
            {
                return nombre;
            }
            set
            {
                nombre = value;
            }
        }

        public string Algoritmo
        {
            get
            {
                return algoritmo;
            }
            set
            {
                algoritmo = value;
            }
        }

        public string ParamsAlgoritmo
        {
            get
            {
                return paramsAlgoritmo;
            }
            set
            {
                paramsAlgoritmo = value;
            }
        }

        public byte[] ClaveSimetrica
        {
            get
            {
                return claveSimetrica;
            }
            set
            {
                claveSimetrica = value;
            }
        }
          
        // devuelve una representacin en byte[] del objeto InfoCabecera
        internal byte[] aBytes()
        {
            MemoryStream memStream = new MemoryStream();
            BinaryWriter binWriter = new BinaryWriter(memStream);

            binWriter.Write(nombre);
            binWriter.Write('\0');
            binWriter.Write(algoritmo);
            binWriter.Write('\0');
            binWriter.Write(paramsAlgoritmo);
            binWriter.Write('\0');
            binWriter.Write(claveSimetrica);
            binWriter.Write('\0');

            binWriter.Close();
            memStream.Close();
            return memStream.ToArray();
        }
    }
}
