using System;
using System.Collections.Generic;
using java.security;
using Org.BouncyCastle.Crypto;

namespace Proyecto
{
    /*
     * Clase ParClavePublicaNombreAlgoritmo: almacena una clave pblica codificada en bytes
     * y el nombre del algoritmo al que est destinada
     * Autor: Juan lvaro Muoz Naranjo
     * Fecha: Junio de 2007
     */
    [Serializable]
    class ParClavePublicaNombreAlgoritmo
    {
        private string nombreAlgoritmo;
        private byte[] clavePublica;

        //constructor genrico
        internal ParClavePublicaNombreAlgoritmo(string nombreAlgoritmo, byte[] clavePublica)
        {
            this.nombreAlgoritmo = nombreAlgoritmo;
            this.clavePublica = clavePublica;
        }

        //constructor para claves pblicas RSA
        internal ParClavePublicaNombreAlgoritmo(PublicKey clavePublicaRSA)
        {
            this.nombreAlgoritmo = clavePublicaRSA.getAlgorithm();
            this.clavePublica = clavePublicaRSA.getEncoded();
        }

        //constructor para claves pblicas ElGamal
        internal ParClavePublicaNombreAlgoritmo(AsymmetricKeyParameter clavePublicaElGamal)
        {
            this.nombreAlgoritmo = "ElGamal";
            this.clavePublica = Utilidades.codificarClaveElGamal(clavePublicaElGamal);
        }

        internal string NombreAlgoritmo
        {
            get
            {
                return nombreAlgoritmo;
            }
        }

        internal byte[] ClavePublica
        {
            get
            {
                return clavePublica;
            }
        }
    }
}
