﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Windows.Forms;

namespace Proyecto
{
    static class Program
    {
        /// <summary>
        /// Punto de entrada principal para la aplicación.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            try
            {
                //si los archivos del sistema no existen es que es la primera vez que se instala el programa, los creamos nuevos
                //también creamos nueva la carpeta cifrada
                if (!File.Exists("usuarios.usr") && !File.Exists("listaClaveSistema.lcs"))
                {
                    if (!Directory.Exists(@"C:\CarpetaCifrada"))
                        Directory.CreateDirectory(@"C:\CarpetaCifrada");
                    crearArchivosDeSistema();
                    Datos.limpiar();
                }
                FormPedirContraseña formPedirContraseña = new FormPedirContraseña();
                Application.Run(formPedirContraseña);
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message);
            }
        }

        //muestra una ventana para crear un usuario por primera vez y a partir de ahí 
        //generar los archivos "usuarios.usr" y "listaClaveSistema.lcs"
        static void crearArchivosDeSistema()
        {
            try
            {
                Datos.ClaveSistema = Utilidades.generarClaveDES();

                FormCrearUsuario formCrearUsuario = new FormCrearUsuario(null, null);
                formCrearUsuario.ShowDialog();
            }
            catch
            {
                MessageBox.Show("Error al generar los archivos del sistema.");
            }
        }
    }
}